﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Grid.Helpers;

namespace UnBoundRowDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();       
            sfDataGrid.QueryUnBoundRow += sfDataGrid_QueryUnBoundRow;
            sfDataGrid.UnBoundRowCellRenderers.Add("GridUnBoundRowCellTextBoxRendererExt", new GridUnBoundRowCellTextBoxRendererExt());
        }


     
        void sfDataGrid_QueryUnBoundRow(object sender, Syncfusion.UI.Xaml.Grid.GridUnBoundRowEventsArgs e)
        {
            if (e.UnBoundAction == UnBoundActions.QueryData)
            {
                if (e.GridUnboundRow.UnBoundRowIndex == 0 && e.GridUnboundRow.Position == UnBoundRowsPosition.Top)
                {
                    if (e.RowColumnIndex.ColumnIndex == 2)
                    {
                        e.CellType = "GridUnBoundRowCellTextBoxRendererExt";
                        e.Value = (sfDataGrid.DataContext as SalesInfoViewModel).DisplayValue;
                        e.Handled = true;                      
                    }
                }
            }
            else if(e.UnBoundAction == UnBoundActions.CommitData)
            {
                if(e.Value!=null)
                    (sfDataGrid.DataContext as SalesInfoViewModel).DisplayValue = e.Value.ToString();
            }
            e.Handled = true;
        }

        private void ComboBox_SelectionChanged(object sender, System.Windows.Controls.SelectionChangedEventArgs e)
        {
            var comboBox = sender as ComboBox;
            if (comboBox != null && comboBox.SelectedItem != null)
            {
                (sfDataGrid.DataContext as SalesInfoViewModel).DisplayValue = (comboBox.SelectedItem as ComboBoxItem).Content.ToString();
                //sfDataGrid.InValidateUnBoundRow(sfDataGrid.UnBoundRows[0]);
                //sfDataGrid.GetVisualContainer().InvalidateMeasure();
                var binding = new Binding();
                binding.Converter = new CurrencyConverter();
                binding.ConverterParameter = (comboBox.SelectedItem as ComboBoxItem).Content;
                sfDataGrid.Columns[2].DisplayBinding = binding;
                sfDataGrid.Columns[2].ValueBinding = binding;
            }
        }
    }
}
